// VString Header File

#ifndef VSTRING_CLASS
#define VSTRING_CLASS

#include "Generic.h"

class VString 
{
	public:
				
				VString (const char *InputString ="");	
				~VString ();
				
				VString(const VString &other);
				
				void Display (void) const;
				void Display (const char *prefix, const char *suffix, BOOL needCRLF) const;
				void Put_At (const char Character, const int Index);
				char Get_At (const int Index) const;

				VString &operator= (const VString &other);
				VString &operator= (const char *other); 
				//	void operator= (const VString &other);  // only different by return type
	
				BOOL operator== (const VString &other) const;
				BOOL operator== (const char *other) const;

				void operator+= (const VString &other);
				void operator+= (const char *other);

				void Append (const VString &other);
				void Append (const char *other);

				void Display_Substring (const int Start, const int End) const;
				BOOL Is_Empty(void) const;
				BOOL Length(void) const;

				BOOL operator! (void) const;



				

	private:
				
				int   m_length;		// length of the string
				char *m_string;		// character pointer to a flexible string data array
};

#endif